package ca.ubc.cs.beta.hydra.builders;

import java.io.Serializable;
import java.util.List;

import ca.ubc.cs.beta.hydra.json.SMACInputJson;

import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import ca.ubc.cs.beta.aeatk.algorithmrunresult.AlgorithmRunResult;
import ca.ubc.cs.beta.aeatk.json.JSONConverter;
import ca.ubc.cs.beta.aeatk.json.serializers.ParameterConfigurationSpaceJson;
import ca.ubc.cs.beta.aeatk.parameterconfigurationspace.ParameterConfiguration;
import ca.ubc.cs.beta.aeatk.probleminstance.ProblemInstance;
import ca.ubc.cs.beta.aeatk.smac.SMACOptions;



@JsonDeserialize(using=SMACInputJson.SMACInputDeserializer.class)
@JsonSerialize(using=SMACInputJson.SMACInputSerializer.class)
public class SMACInput implements Serializable{
    
        private static final long serialVersionUID = -8891189969361543399L;
        public String[] fSMACArgs;
        public List<AlgorithmRunResult> fRuns; /* May need to change to RunHistory */
        public List<ParameterConfiguration> fPortfolio;
        public static JSONConverter<SMACInput> fSMACInputConv = new JSONConverter<SMACInput>(){};
        
        public SMACInput(String[] aSMACArgs, List<AlgorithmRunResult> aRuns, List<ParameterConfiguration> aPortfolio){
            
            fSMACArgs = aSMACArgs;
            fRuns = aRuns;
            fPortfolio = aPortfolio;
            //fInstanceSeedGenerator aInstanceSeedGenerator
            
        }
        
        public SMACInput()
        {
            
        }
        
        
        @Override
        public boolean equals(Object o)
        {
            if(this == o) return true;
            if(o instanceof SMACInput)
            {
                SMACInput input = (SMACInput) o;
                return  fRuns.equals(input.fRuns) && fPortfolio.equals(input.fPortfolio);
                //fSMACArgs.equals(input.fSMACArgs) &&
            }
            return false;
        }
        
        @Override
        public String toString()
        {
            StringBuilder out = new StringBuilder();
            out.append("SMAC arguments: " + fSMACArgs + "\n");
            out.append("Algorithm Run Results: " + fRuns + "\n");
            out.append("Hydra Portfolio: " + fPortfolio + "\n");
            
            return out.toString();
        }

}
