package ca.ubc.cs.beta.hydra.builders;

import java.io.Serializable;
import java.util.List;

import ca.ubc.cs.beta.hydra.json.SMACResultJson;

import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import ca.ubc.cs.beta.aeatk.algorithmrunresult.AlgorithmRunResult;
import ca.ubc.cs.beta.aeatk.json.JSONConverter;
import ca.ubc.cs.beta.aeatk.parameterconfigurationspace.ParameterConfiguration;

@JsonDeserialize(using=SMACResultJson.SMACResultDeserializer.class)
@JsonSerialize(using=SMACResultJson.SMACResultSerializer.class)
public class SMACResult implements Serializable {
    
    private static final long serialVersionUID = -5441247553117323311L;
    public ParameterConfiguration fIncumbent;
    public List<AlgorithmRunResult> fRuns; /* May need to change to RunHistory */
    public String fTerminationReason;
    public static JSONConverter<SMACResult> fSMACResultConv = new JSONConverter<SMACResult>(){};
    
    public SMACResult(ParameterConfiguration aIncumbent, List<AlgorithmRunResult> aRuns, String aTerminationReason){
        fIncumbent = aIncumbent;
        fRuns = aRuns;
        fTerminationReason = aTerminationReason;
    }
    
    public SMACResult()
    {
        
    }
    
    @Override
    public boolean equals(Object o)
    {
        if(this == o) return true;
        if(o instanceof SMACResult)
        {
            SMACResult result = (SMACResult) o;
            return fIncumbent.equals(result.fIncumbent) && fRuns.equals(result.fRuns) && fTerminationReason.equals(result.fTerminationReason);
        }
        return false;
    }
    
    @Override
    public String toString()
    {
        StringBuilder out = new StringBuilder();
        out.append("SMAC incumbent: " + fIncumbent.getFormattedParameterString() + "\n");
        out.append("Algorithm Run Results: " + fRuns + "\n");
        out.append("Termination reason: " + fTerminationReason + "\n");
        
        return out.toString();
    }

}
