package ca.ubc.cs.beta.hydra.builders;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import org.mangosdk.spi.ProviderFor;

import ca.ubc.cs.beta.aeatk.algorithmrunconfiguration.AlgorithmRunConfiguration;
import ca.ubc.cs.beta.aeatk.algorithmrunresult.AlgorithmRunResult;
import ca.ubc.cs.beta.aeatk.algorithmrunresult.ExistingAlgorithmRunResult;
import ca.ubc.cs.beta.aeatk.algorithmrunresult.RunStatus;
import ca.ubc.cs.beta.aeatk.options.AbstractOptions;
import ca.ubc.cs.beta.aeatk.parameterconfigurationspace.ParameterConfiguration;
import ca.ubc.cs.beta.aeatk.targetalgorithmevaluator.AbstractAsyncTargetAlgorithmEvaluator;
import ca.ubc.cs.beta.aeatk.targetalgorithmevaluator.AbstractSyncTargetAlgorithmEvaluator;
import ca.ubc.cs.beta.aeatk.targetalgorithmevaluator.AbstractTargetAlgorithmEvaluator;
import ca.ubc.cs.beta.aeatk.targetalgorithmevaluator.TargetAlgorithmEvaluatorCallback;
import ca.ubc.cs.beta.aeatk.targetalgorithmevaluator.TargetAlgorithmEvaluatorFactory;
import ca.ubc.cs.beta.aeatk.targetalgorithmevaluator.TargetAlgorithmEvaluatorRunObserver;



public class SMACTAE extends AbstractSyncTargetAlgorithmEvaluator {

    private final AbstractOptions fOptions;

    public SMACTAE(AbstractOptions options)
    {
        fOptions = options;
    }
    
    
    @Override
    public boolean isRunFinal() {
        // TODO Auto-generated method stub
        return false;
    }

    @Override
    public boolean areRunsPersisted() {
        // TODO Auto-generated method stub
        return false;
    }

    @Override
    public boolean areRunsObservable() {
        // TODO Auto-generated method stub
        return false;
    }

    @Override
    public List<AlgorithmRunResult> evaluateRun(
            List<AlgorithmRunConfiguration> runConfigs,
            TargetAlgorithmEvaluatorRunObserver runStatusObserver) {
        
        /* Decompress run */
        List<AlgorithmRunConfiguration> decompressedRuns = CompressionTargetAlgorithmEvaluatorDecorator.getDecompressedRunConfig(runConfigs);
        
        List<AlgorithmRunResult> results = new ArrayList<AlgorithmRunResult>();
        
        for(AlgorithmRunConfiguration run : decompressedRuns)
        {
            SMACHydraWrapper wrapper;
            try {
                wrapper = new SMACHydraWrapper(run);
                results.add(wrapper.getResult());
            } catch (Throwable e) {
                e.printStackTrace();

                String terminationReason = "Error executing SMAC wrapper: " + e.getMessage();
                ParameterConfiguration dummyIncumbent = null;
                List<AlgorithmRunResult> runResults = new ArrayList<AlgorithmRunResult>();
                SMACResult smacResult = new SMACResult(dummyIncumbent,runResults,terminationReason);
                
                RunStatus aresult = RunStatus.SAT;
                double runtime = Double.MAX_VALUE;
                String additionalRunData = SMACResult.fSMACResultConv.getJSON(smacResult);
                
                long aSeed = 0;
                AlgorithmRunResult runResult = new ExistingAlgorithmRunResult(run,aresult,runtime, 0, -1, aSeed, additionalRunData);
                results.add(runResult);
            }
            
        }
        
        /* Compress results */
        return CompressionTargetAlgorithmEvaluatorDecorator.getCompressedRunResult(results);
        
    }

    @Override
    protected void subtypeShutdown() {
        //TODO: No idea what this refers to.
    }

}
