package ca.ubc.cs.beta.hydra.builders;

import ca.ubc.cs.beta.hydra.executors.SMACTAEOptions;

import org.mangosdk.spi.ProviderFor;

import ca.ubc.cs.beta.aeatk.options.AbstractOptions;
import ca.ubc.cs.beta.aeatk.targetalgorithmevaluator.AbstractTargetAlgorithmEvaluatorFactory;
import ca.ubc.cs.beta.aeatk.targetalgorithmevaluator.TargetAlgorithmEvaluator;
import ca.ubc.cs.beta.aeatk.targetalgorithmevaluator.TargetAlgorithmEvaluatorFactory;

@ProviderFor(TargetAlgorithmEvaluatorFactory.class)
public class SMACTAEFactory extends AbstractTargetAlgorithmEvaluatorFactory {

    @Override
    public String getName() {
        return "SMAC";
    }

    @Override
    public TargetAlgorithmEvaluator getTargetAlgorithmEvaluator(AbstractOptions options) 
    {    
        TargetAlgorithmEvaluator tae =  new SMACTAE(options);
        
        return tae;
    }

    @Override
    public AbstractOptions getOptionObject() {
        return new SMACTAEOptions();
    }
    
    
    
}
