package ca.ubc.cs.beta.hydra.executors;
//package ca.ubc.cs.beta.hydra.executors;
//
//import java.io.File;
//import java.io.FileWriter;
//import java.io.IOException;
//import java.io.PrintWriter;
//import java.io.StringWriter;
//import java.lang.management.ManagementFactory;
//import java.net.InetAddress;
//import java.net.UnknownHostException;
//import java.util.ArrayList;
//import java.util.HashMap;
//import java.util.HashSet;
//import java.util.List;
//import java.util.Map;
//import java.util.Set;
//import java.util.TreeMap;
//import java.util.Map.Entry;
//
//import org.slf4j.Logger;
//import org.slf4j.LoggerFactory;
//import org.slf4j.Marker;
//import org.slf4j.MarkerFactory;
//
//import com.beust.jcommander.JCommander;
//import com.beust.jcommander.ParameterException;
//
//import ca.ubc.cs.beta.aclib.algorithmrun.AlgorithmRun;
//import ca.ubc.cs.beta.aclib.algorithmrun.ExistingAlgorithmRun;
//import ca.ubc.cs.beta.aclib.configspace.ParamConfiguration;
//import ca.ubc.cs.beta.aclib.configspace.ParamConfiguration.StringFormat;
//import ca.ubc.cs.beta.aclib.exceptions.DuplicateRunException;
//import ca.ubc.cs.beta.aclib.exceptions.StateSerializationException;
//import ca.ubc.cs.beta.aclib.exceptions.TrajectoryDivergenceException;
//import ca.ubc.cs.beta.aclib.execconfig.AlgorithmExecutionConfig;
//import ca.ubc.cs.beta.aclib.misc.jcommander.JCommanderHelper;
//import ca.ubc.cs.beta.aclib.misc.options.UsageSection;
//import ca.ubc.cs.beta.aclib.misc.returnvalues.ACLibReturnValues;
//import ca.ubc.cs.beta.aclib.misc.spi.SPIClassLoaderHelper;
//import ca.ubc.cs.beta.aclib.misc.version.VersionTracker;
//import ca.ubc.cs.beta.aclib.misc.watch.AutoStartStopWatch;
//import ca.ubc.cs.beta.aclib.misc.watch.StopWatch;
//import ca.ubc.cs.beta.aclib.objectives.OverallObjective;
//import ca.ubc.cs.beta.aclib.objectives.RunObjective;
//import ca.ubc.cs.beta.aclib.options.AbstractOptions;
//import ca.ubc.cs.beta.aclib.options.docgen.UsageSectionGenerator;
//import ca.ubc.cs.beta.aclib.options.scenario.ScenarioOptions;
//import ca.ubc.cs.beta.aclib.probleminstance.InstanceListWithSeeds;
//import ca.ubc.cs.beta.aclib.probleminstance.ProblemInstance;
//import ca.ubc.cs.beta.aclib.probleminstance.ProblemInstanceSeedPair;
//import ca.ubc.cs.beta.aclib.random.SeedableRandomPool;
//import ca.ubc.cs.beta.aclib.runconfig.RunConfig;
//import ca.ubc.cs.beta.aclib.runhistory.NewRunHistory;
//import ca.ubc.cs.beta.aclib.seedgenerator.InstanceSeedGenerator;
//import ca.ubc.cs.beta.aclib.targetalgorithmevaluator.TargetAlgorithmEvaluator;
//import ca.ubc.cs.beta.aclib.targetalgorithmevaluator.decorators.debug.SanityCheckingTargetAlgorithmEvaluatorDecorator;
//import ca.ubc.cs.beta.aclib.targetalgorithmevaluator.decorators.helpers.StrictlyIncreasingRuntimesTargetAlgorithmEvaluatorDecorator;
//import ca.ubc.cs.beta.aclib.targetalgorithmevaluator.decorators.helpers.UseDynamicCappingExclusivelyTargetAlgorithmEvaluatorDecorator;
//import ca.ubc.cs.beta.aclib.targetalgorithmevaluator.decorators.resource.caching.CachingTargetAlgorithmEvaluatorDecorator;
//import ca.ubc.cs.beta.aclib.targetalgorithmevaluator.init.TargetAlgorithmEvaluatorLoader;
//import ca.ubc.cs.beta.dsmac.builder.DSMACBuilder;
//import ca.ubc.cs.beta.dsmac.configurator.DistributedAutomaticConfigurator;
//import ca.ubc.cs.beta.dsmac.options.DSMACOptions;
//import ca.ubc.cs.beta.hydra.tae.PortfolioTargetAlgorithmEvaluatorDecorator;
//import ca.ubc.cs.beta.smac.builder.SMACBuilder;
//import ca.ubc.cs.beta.smac.configurator.AbstractAlgorithmFramework;
//
//
//
//public class DHydraExecutor {
//
//	/**
//	 * Do not populate until CLI arguments are parsed.
//	 */
//	private static Logger log;
//	
//	//private static String logLocation;
//	
//	private static Marker exception;
//	private static Marker stackTrace;
//	
//	private static List<ProblemInstance> instances;
//	
//	
//	private static InstanceSeedGenerator instanceSeedGen;
//	private static String logLocation = "<NO LOG LOCATION SPECIFIED, FAILURE MUST HAVE OCCURED EARLY>";
//	
//	private static SeedableRandomPool pool;
//	public static void main(String[] args)
//	{
//		
//				
//		int returnValue = dSMAC(args);
//		
//		if(log != null)
//		{
//			log.info("Returning with value: {}",returnValue);
//		}
//		
//		
//		System.exit(returnValue);
//	}
//	
//	public static String savePath = null;
//	
//	
//	private static DSMACOptions dsmacOptions = new DSMACOptions();
//	private static Map<String, AbstractOptions> taeOptions = null;
//	
//	/**
//	 * Static method that actually invokes the dSMAC Automatic Configuration Procedure
//	 * @param args
//	 * @return return value
//	 */
//	public static int dSMAC(String[] args)
//	{
//		/*
//		 * WARNING: DO NOT LOG ANYTHING UNTIL AFTER WE HAVE PARSED THE CLI OPTIONS
//		 * AS THE CLI OPTIONS USE A TRICK TO ALLOW LOGGING TO BE CONFIGURABLE ON THE CLI
//		 * IF YOU LOG PRIOR TO IT ACTIVATING, IT WILL BE IGNORED 
//		 */
//		try {
//			parseCLIOptions(args);
//			
//			DSMACOptions options = dsmacOptions;
//
//			final int origNumRun = dsmacOptions.seedOptions.numRun;
//			final AlgorithmExecutionConfig execConfig = dsmacOptions.getAlgorithmExecutionConfig();
//			final List<ParamConfiguration> portfolios = new ArrayList<ParamConfiguration>();
//			
//			
//			TargetAlgorithmEvaluator myTAE = options.scenarioConfig.algoExecOptions.taeOpts.getTargetAlgorithmEvaluator( taeOptions, savePath, options.seedOptions.numRun);
//			
//			myTAE = new CachingTargetAlgorithmEvaluatorDecorator(myTAE);
//			myTAE = new StrictlyIncreasingRuntimesTargetAlgorithmEvaluatorDecorator(myTAE);
//			myTAE = new UseDynamicCappingExclusivelyTargetAlgorithmEvaluatorDecorator(myTAE);
//			
//			final NewRunHistory rh = new NewRunHistory(options.scenarioConfig.intraInstanceObj, options.scenarioConfig.interInstanceObj, options.scenarioConfig.runObj);
//			
//			
//			try 
//			{
//				for(int i=0; i < 10; i++)
//				{
//					try
//					{
//					
//					
//						final NewRunHistory modelRH = new NewRunHistory(options.scenarioConfig.intraInstanceObj, options.scenarioConfig.interInstanceObj, options.scenarioConfig.runObj);
//						TargetAlgorithmEvaluator tae = myTAE;
//						
//						
//						if(portfolios.size() > 0)
//						{
//							
//							if(portfolios.size() > 1)
//							{
//								tae = new PortfolioTargetAlgorithmEvaluatorDecorator(myTAE, portfolios, options.scenarioConfig.runObj, options.scenarioConfig.algoExecOptions.cutoffTime);
//							}
//							log.info("Determining Portfolio Performance to rebuild model");
//							
//							StopWatch watch = new AutoStartStopWatch();
//							Set<ProblemInstanceSeedPair> pisps = new HashSet<ProblemInstanceSeedPair>();
//							for(ParamConfiguration config : rh.getAllParameterConfigurationsRan())
//							{
//								pisps.addAll(rh.getProblemInstanceSeedPairsRan(config));
//							}
//							
//							log.info("Total Problem Instance Seed Pairs Ran {} ", pisps.size());
//							
//							List<RunConfig> runConfigs = new ArrayList<RunConfig>(); 
//							for(ProblemInstanceSeedPair pisp : pisps)
//							{
//								runConfigs.add(new RunConfig(pisp, portfolios.get(0), execConfig));
//							}
//							
//							List<AlgorithmRun> pRuns =  tae.evaluateRun(runConfigs);
//							
//							Map<ProblemInstanceSeedPair, Double> portfolioPerformance = new HashMap<ProblemInstanceSeedPair, Double>();
//							Map<ProblemInstanceSeedPair, AlgorithmRun> portfolioRuns = new HashMap<ProblemInstanceSeedPair, AlgorithmRun>();
//							
//							for(AlgorithmRun prun : pRuns)
//							{
//								portfolioPerformance.put(prun.getRunConfig().getProblemInstanceSeedPair(), options.scenarioConfig.runObj.getObjective(prun));
//								portfolioRuns.put(prun.getRunConfig().getProblemInstanceSeedPair(), prun);
//							}
//							
//							
//							for(AlgorithmRun run : rh.getAlgorithmRunsExcludingRedundant())
//							{
//								
//								try {
//									switch(options.scenarioConfig.runObj)
//									{
//									case RUNTIME:
//										
//										if(options.scenarioConfig.runObj.getObjective(run) < portfolioPerformance.get(run.getRunConfig().getProblemInstanceSeedPair()))
//										{
//											modelRH.append(run);
//										} else
//										{
//											AlgorithmRun prun = portfolioRuns.get(run.getRunConfig().getProblemInstanceSeedPair());
//											
//											modelRH.append(new ExistingAlgorithmRun(run.getRunConfig(),prun.getRunResult(),prun.getRuntime(), prun.getRunLength(),prun.getQuality(),prun.getResultSeed(),prun.getAdditionalRunData(),prun.getWallclockExecutionTime()));
//										}
//										break;
//									default:
//										throw new IllegalArgumentException("RunObjective " + options.scenarioConfig.runObj + " is not supported");
//									}
//								} catch(DuplicateRunException e)
//								{
//									//Don't care about duplicate runs
//								}
//		
//							}
//							
//							log.info("Building model data for next iteration of hydra took {} seconds, have {} points",watch.stop() / 1000.0, modelRH.getAlgorithmRunData().size());
//							
//							if(portfolios.size() == 1)
//							{
//								tae = new PortfolioTargetAlgorithmEvaluatorDecorator(myTAE, portfolios, options.scenarioConfig.runObj, options.scenarioConfig.algoExecOptions.cutoffTime);
//							}
//						}
//						
//						
//						//tae = new LogEveryObservationTargetAlgorithmEvaluatorDecorator(tae);
//						tae = new SanityCheckingTargetAlgorithmEvaluatorDecorator(tae);
//						
//						
//						//SMACBuilder smacBuilder = new SMACBuilder();
//						
//						//AbstractAlgorithmFramework smac;
//						
//						
//						options.seedOptions.numRun = i;
//						String outputDirRun = savePath + File.separator + "dHydraRun" + "-" + origNumRun;
//						if(!new File(outputDirRun).exists() & !new File(outputDirRun).mkdirs())
//						{
//							throw new ParameterException ("Unable to create output directory:" + outputDirRun);
//						}
//						
//						
//						
//						
//						DSMACBuilder dsmacBuilder = new DSMACBuilder();
//						
//						
//						dsmacBuilder.setOptions(dsmacOptions, taeOptions);
//						dsmacBuilder.setInstances(instances);
//						dsmacBuilder.setInstanceSeedGenerator(instanceSeedGen);
//						
//						//dsmacBuilder.setInstancesAndSeedGenFromOptions(options);
//						
//						dsmacBuilder.setRandomPool(pool);
//						
//						dsmacBuilder.setTargetAlgorithmEvaluator(tae);
//						
//						final DistributedAutomaticConfigurator dac = dsmacBuilder.getSMAC(savePath);
//								
//						
//						dac.run();
//						
//						
//						
//						ParamConfiguration finalIncumbent = dac.getFinalIncumbent();
//						pool.logUsage();
//						
//						log.info("Final Incumbent: {}" , finalIncumbent.getFormattedParamString(StringFormat.NODB_SYNTAX));
//						
//						
//						/*
//						smac = smacBuilder.getAutomaticConfigurator(execConfig,  trainingILWS, options, taeOptions, outputDirRun, pool, tae, modelRH);
//					
//						log.info("Final TAE Built :{}", tae);
//						smac.run();
//						*/
//						
//
//						
//						/*
//						for(AlgorithmRun run : smac.getRunHistory().getAlgorithmRunsExcludingRedundant())
//						{
//							try {
//								rh.append(run);
//							} catch(DuplicateRunException e)
//							{
//								//Duplicate run who cares
//							}
//						}
//						*/
//						
//						pool.logUsage();
//						
//						/*
//						log.info("SMAC Termination Reason: {}",smac.getTerminationReason() );
//						log.info("Final Incumbent: {}", smac.getIncumbent().getFormattedParamString());
//						 */
//						ParamConfiguration newInc = null; //smac.getIncumbent();
//						if(portfolios.contains(newInc))
//						{
//							log.info("HYDRA detected that SMAC returned a configuration in the portfolio, this means that HYDRA has stagnated at this point");
//							break;
//						} else
//						{
//							portfolios.add(newInc);
//						}
//							
//						
//						
//						
//					} finally
//					{
//						File f = new File(savePath+File.separator + "dHydraRun" + "-" + origNumRun + File.separator+ "portfolio-"+i+".txt");
//						FileWriter fWrite = new FileWriter(f); 
//						int j=0;
//						for(ParamConfiguration config : portfolios)
//						{
//							fWrite.append( j + ":" + config.getFormattedParamString(StringFormat.NODB_SYNTAX) + "\n");
//							j++;
//						}
//						fWrite.flush();
//						fWrite.close();
//					}
//					
//				}
//			} finally
//			{
//				int i=0;
//				for(ParamConfiguration portfolio : portfolios)
//				{
//					log.info("Portfolio Configuration :  {}" ,  portfolio.getFormattedParamString());
//					i++;
//				}
//				
//				myTAE.notifyShutdown();
//			}
//			
//			
//			
//			//log.info("Automatic Configurator Started");
//			
//			
//			
//		
//			
//			/*
//			dsmacBuilder.getTargetAlgorithmEvaluator().notifyShutdown();
//			
//			if(dac.getFailure() != null)
//			{
//				throw dac.getFailure();
//			}
//			*/
//			log.info("dHydra Completed Successfully. Log: " + logLocation);
//			
//			return ACLibReturnValues.SUCCESS;
//		} catch(Throwable t)
//		{
//			System.out.flush();
//			System.err.flush();
//			
//			System.err.println("Error occured running SMAC ( " + t.getClass().getSimpleName() + " : "+ t.getMessage() +  ")\nError Log: " + logLocation);
//			System.err.flush();
//			
//				if(log != null)
//				{
//					
//					log.error(exception, "Message: {}",t.getMessage());
//
//					if(!(t instanceof ParameterException))
//					{
//						log.info("Maybe try running in DEBUG mode if you are missing information");
//						log.error(exception, "Exception:{}", t.getClass().getCanonicalName());
//						StringWriter sWriter = new StringWriter();
//						PrintWriter writer = new PrintWriter(sWriter);
//						t.printStackTrace(writer);
//						log.error(stackTrace, "StackTrace:{}",sWriter.toString());
//						
//					} else
//					{
//						log.debug("Exception stack trace", t);
//					}
//					
//						
//					
//					
//					log.info("Exiting SMAC with failure. Log: " + logLocation);
//					t = t.getCause();
//				} else
//				{
//					if(t instanceof ParameterException )
//					{
//						
//						System.err.println("ERROR: " + t.getMessage());
//					}
//					
//					t.printStackTrace();
//					
//					
//				}
//		
//				
//				if(t instanceof ParameterException)
//				{
//					return ACLibReturnValues.PARAMETER_EXCEPTION;
//				}
//				
//				if(t instanceof StateSerializationException)
//				{
//					return ACLibReturnValues.SERIALIZATION_EXCEPTION;
//				}
//				
//				if(t instanceof TrajectoryDivergenceException)
//				{
//					return ACLibReturnValues.TRAJECTORY_DIVERGENCE;
//				}
//				
//				return ACLibReturnValues.OTHER_EXCEPTION;
//		}
//		
//	}
//
//
//	private static void parseCLIOptions(String[] args) throws IOException {
//		
//		
//		
//		taeOptions = TargetAlgorithmEvaluatorLoader.getAvailableTargetAlgorithmEvaluators();
//		
//		
//		DSMACOptions options = dsmacOptions;
//		
//		JCommander jcom = JCommanderHelper.getJCommanderAndCheckForHelp(args,options, taeOptions);
//		jcom.setProgramName("dsmac");
//		String runGroupName;
//		try {
//			
//			File outputDir = new File(options.experimentDir + File.separator);
//			//JCommanderHelper.parse(com, args);
//			try {
//				try {
//				
//					jcom.parse(args);
//				} finally
//				{
//					runGroupName = options.runGroupOptions.getFailbackRunGroup();
//				}
//				
//				/*
//				 * 
//				 * } finally
//				{
//					
//				}
//				
//				
//
//				if(options.adaptiveCapping == null)
//				{
//					switch(options.scenarioConfig.runObj)
//					{
//					case RUNTIME:
//						options.adaptiveCapping = true;
//						break;
//						
//					case QUALITY:
//						options.adaptiveCapping = false;
//						break;
//						
//					default:
//						//You need to add something new here
//						throw new IllegalStateException("Not sure what to default too");
//					}
//				}
//				
//				
//			
//				 * 
//				 * 
//				 */
//				runGroupName = options.getRunGroupName(taeOptions.values());
//				savePath = options.scenarioConfig.outputDirectory + File.separator + runGroupName + File.separator;
//				File saveLocation = new File(savePath);
//				if(!saveLocation.isAbsolute())
//				{
//					savePath = new File(options.experimentDir + File.separator + savePath).getAbsolutePath();
//				} 
//				
//				 outputDir = new File(savePath);
//				if(!outputDir.exists())
//				{
//					outputDir.mkdir();
//				}
//				
//				
//				
//			} finally
//			{
//				System.setProperty("OUTPUTDIR", outputDir.getAbsolutePath());
//				System.setProperty("RUNGROUPDIR", File.separator);
//				System.setProperty("NUMRUN", String.valueOf(options.seedOptions.numRun));
//				System.setProperty("STDOUT-LEVEL", options.consoleLogLevel.name());
//				System.setProperty("ROOT-LEVEL",options.logLevel.name());
//				
//				logLocation = outputDir.getAbsolutePath() + File.separator + "log-run" + options.seedOptions.numRun+ ".txt";
//				
//				System.out.println("*****************************\nLogging to: " + logLocation +  "\n*****************************");
//				//${OUTPUTDIR}/${RUNGROUPDIR}/log-run${NUMRUN}.txt
//				log = LoggerFactory.getLogger(DHydraExecutor.class);
//				exception = MarkerFactory.getMarker("EXCEPTION");
//				stackTrace = MarkerFactory.getMarker("STACKTRACE");
//				
//				//VersionTracker.loadVersionFromClassPath("SMAC", "smac-version.txt");
//				VersionTracker.setClassLoader(SPIClassLoaderHelper.getClassLoader());
//				VersionTracker.logVersions();
//				
//				//Logs the available target algorithm evaluators
//				for(String name : taeOptions.keySet())
//				{
//					log.info("Target Algorithm Evaluator Available: {} ", name);
//				}
//				
//				for(String name : jcom.getParameterFilesToRead())
//				{
//					log.info("Parsing (default) options from file: {} ", name);
//				}
//				
//			}
//			
//			log.trace("Command Line Options Parsed");
//			
//			
//			
//			if(options.adaptiveCapping == null)
//			{
//				switch(options.scenarioConfig.runObj)
//				{
//				case RUNTIME:
//					options.adaptiveCapping = true;
//					break;
//					
//				case QUALITY:
//					options.adaptiveCapping = false;
//					break;
//					
//				default:
//					//You need to add something new here
//					throw new IllegalStateException("Not sure what to default too");
//				}
//			}
//			
//			validateObjectiveCombinations(options.scenarioConfig, options.adaptiveCapping);
//			
//			JCommanderHelper.logCallString(args, DHydraExecutor.class);
//		
//			
//			if(options.logLevel.lessVerbose(options.consoleLogLevel))
//			{
//				log.warn("The console has been set to be more verbose than the log. This is generally an error, except if you have modified the conf.xml to have certain loggers be more specific");
//				//throw new ParameterException("The console can NOT be more verbose than the logs (This will have no effect)");
//				
//			}
//				
//			
//			
//			 
//			 if(log.isDebugEnabled())
//			 {
//				Map<String, String> env = new TreeMap<String, String>(System.getenv());
//					
//				StringBuilder sb = new StringBuilder();
//				 for (String envName : env.keySet()) {
//					 sb.append(envName).append("=").append(env.get(envName)).append("\n");
//					 
//			           
//			        }
//				
//				
//					 
//				 log.debug("==========Enviroment Variables===========\n{}", sb.toString());
//				 
//				 
//				 Map<Object,Object > props = new TreeMap<Object, Object>(System.getProperties());
//				 sb = new StringBuilder();
//				 for (Entry<Object, Object> ent : props.entrySet())
//				 {
//					 
//					 sb.append(ent.getKey().toString()).append("=").append(ent.getValue().toString()).append("\n");
//					 
//			           
//			     }
//				
//				 String hostname = "[UNABLE TO DETERMINE HOSTNAME]";
//				try {
//					hostname = InetAddress.getLocalHost().getHostName();
//				} catch(UnknownHostException e)
//				{ //If this fails it's okay we just use it to output to the log
//					
//				}
//				
//				log.debug("Hostname:{}", hostname);
//				log.debug("==========System Properties==============\n{}", sb.toString() );
//			 }
//			
//			log.info("==========Configuration Options==========\n{}", options.toString());
//			pool = options.seedOptions.getSeedableRandomPool();
//			 
//			
//			InstanceListWithSeeds ilws;
//			
//			
//			ilws = options.getTrainingAndTestProblemInstances(pool).getTrainingInstances();
//
//			instanceSeedGen = ilws.getSeedGen();
//			
//			instances = ilws.getInstances();
//			
//			try {
//				//We don't handle this more gracefully because this seems like a super rare incident.
//				if(ManagementFactory.getThreadMXBean().isThreadCpuTimeEnabled())
//				{
//					log.debug("JVM Supports CPU Timing Measurements");
//				} else
//				{
//					log.warn("This Java Virtual Machine has CPU Time Measurements disabled, tunerTimeout will not contain any SMAC Execution Time.");
//				}
//			} catch(UnsupportedOperationException e)
//			{
//				log.warn("This Java Virtual Machine does not support CPU Time Measurements, tunerTimeout will not contain any SMAC Execution Time Information (http://docs.oracle.com/javase/1.5.0/docs/api/java/lang/management/ThreadMXBean.html#setThreadCpuTimeEnabled(boolean))");
//			}
//			
//			
//			return;
//		} catch(IOException e)
//		{
//			
//			try {
//				
//			
//				List<UsageSection> sections = UsageSectionGenerator.getUsageSections(jcom.getObjects().get(0), taeOptions);
//				
//				boolean showHiddenParameters = false;
//				
//				//A much nicer usage screen than JCommander's 
//				//OptionsToUsage.usage(sections, showHiddenParameters);
//				
//				log.error(e.getMessage());
//				
//				
//				
//			} catch (Exception e1) {
//				log.error("Exception occured while trying to generate usage screen",e1);
//				log.error("This exception did NOT cause SMAC to crash");
//			}
//			throw e;
//			
//		} catch(ParameterException e)
//		{
//			try {
//
//				//Converts the actual option objects into objects "UsageSection"s that are easy to manipulate
//				List<UsageSection> sections = UsageSectionGenerator.getUsageSections(jcom.getObjects().get(0), taeOptions);
//				
//				boolean showHiddenParameters = false;
//				
//				//A much nicer usage screen than JCommander's 
//				//OptionsToUsage.usage(sections, showHiddenParameters);
//				
//				log.error(e.getMessage());
//				
//				
//				
//			} catch (Exception e1) {
//				log.error("Exception occured while trying to generate usage screen",e1);
//				log.error("This exception did NOT cause SMAC to crash");
//			}
//			
//			throw e;
//		}
//	}
//	
//
//	
//
//	/**
//	 * Validates the various objective functions and ensures that they are legal together
//	 * @param scenarioConfig
//	 */
//	private static void validateObjectiveCombinations(
//			ScenarioOptions scenarioConfig, boolean adaptiveCapping) {
//
//		switch(scenarioConfig.interInstanceObj)
//		{
//			case MEAN:
//				//Okay
//				break;
//			default:
//				throw new ParameterException("Model does not currently support an inter-instance objective other than " +  OverallObjective.MEAN);
//				
//		}
//		
//		
//		
//		
//		switch(scenarioConfig.runObj)
//		{
//			case RUNTIME:
//				break;
//			
//			case QUALITY:
//				if(!scenarioConfig.intraInstanceObj.equals(OverallObjective.MEAN))
//				{
//					throw new ParameterException("To optimize quality you MUST use an intra-instance objective of " + OverallObjective.MEAN);
//				}
//				
//				if(adaptiveCapping)
//				{
//					throw new ParameterException("You can only use Adaptive Capping when using " + RunObjective.RUNTIME + " as an objective");
//				}
//				
//		}
//	}
//	
//}
