package ca.ubc.cs.beta.hydra.options;

import ca.ubc.cs.beta.aeatk.misc.options.NoArgumentHandler;

public class HydraNoArgHandler implements NoArgumentHandler {

    @Override
    public boolean handleNoArguments() {
        StringBuilder sb = new StringBuilder();
        
        sb.append("Hydra (http://www.cs.ubc.ca/labs/beta/Projects/Hydra/) is a portfolio builder that allows users to automatically build portfolios of algorithm configuration spaces.").append("\n\n");

        sb.append("  Basic Usage:\n");
        sb.append("  ./hydra --smac-options <file> --smacTAE-options <file> \n\n");

        sb.append("  Linux/Mac OS X/Windows Example:\n");
        sb.append("  ./hydra --smac-options ./example_scenarios/saps/saps-scenario.txt --smacTAE-options ./example_scenarios/saps/saps-scenario.txt\n\n");
        
        sb.append("  A full command line reference is available with:\n");
        sb.append("  ./hydra --help\n\n");
              
        sb.append("Please check the documentation to directory (doc/) for a quickstart.html which will show you how to get up and running right away.");
        sb.append("\n\n  See also:\n\n");
              
        sb.append("  mysql-worker - for running SMAC and algorithm runs through mysql\n");
        
        sb.append("\n---------------------------------------------------------------\n");
        System.out.println(sb.toString());
        return true;
    }

}
